# coding: utf-8
try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from cloudtower.configuration import Configuration


class SecurityPolicyCreateParams(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'ingress': 'list[SecurityPolicyIngressEgressInput]',
        'egress': 'list[SecurityPolicyIngressEgressInput]',
        'apply_to': 'list[SecurityPolicyApplyToInput]',
        'policy_mode': 'PolicyMode',
        'everoute_cluster_id': 'str',
        'description': 'str',
        'name': 'str'
    }

    attribute_map = {
        'ingress': 'ingress',
        'egress': 'egress',
        'apply_to': 'apply_to',
        'policy_mode': 'policy_mode',
        'everoute_cluster_id': 'everoute_cluster_id',
        'description': 'description',
        'name': 'name'
    }

    def __init__(self, **kwargs):  # noqa: E501
        """SecurityPolicyCreateParams - a model defined in OpenAPI"""  # noqa: E501
        self.local_vars_configuration = kwargs.get("local_vars_configuration", Configuration.get_default_copy())

        self._ingress = None
        self._egress = None
        self._apply_to = None
        self._policy_mode = None
        self._everoute_cluster_id = None
        self._description = None
        self._name = None
        self.discriminator = None

        if "ingress" in kwargs:
            self.ingress = kwargs["ingress"]
        if "egress" in kwargs:
            self.egress = kwargs["egress"]
        if "apply_to" in kwargs:
            self.apply_to = kwargs["apply_to"]
        if "policy_mode" in kwargs:
            self.policy_mode = kwargs["policy_mode"]
        if "everoute_cluster_id" in kwargs:
            self.everoute_cluster_id = kwargs["everoute_cluster_id"]
        if "description" in kwargs:
            self.description = kwargs["description"]
        if "name" in kwargs:
            self.name = kwargs["name"]

    @property
    def ingress(self):
        """Gets the ingress of this SecurityPolicyCreateParams.  # noqa: E501


        :return: The ingress of this SecurityPolicyCreateParams.  # noqa: E501
        :rtype: list[SecurityPolicyIngressEgressInput]
        """
        return self._ingress

    @ingress.setter
    def ingress(self, ingress):
        """Sets the ingress of this SecurityPolicyCreateParams.


        :param ingress: The ingress of this SecurityPolicyCreateParams.  # noqa: E501
        :type ingress: list[SecurityPolicyIngressEgressInput]
        """

        self._ingress = ingress

    @property
    def egress(self):
        """Gets the egress of this SecurityPolicyCreateParams.  # noqa: E501


        :return: The egress of this SecurityPolicyCreateParams.  # noqa: E501
        :rtype: list[SecurityPolicyIngressEgressInput]
        """
        return self._egress

    @egress.setter
    def egress(self, egress):
        """Sets the egress of this SecurityPolicyCreateParams.


        :param egress: The egress of this SecurityPolicyCreateParams.  # noqa: E501
        :type egress: list[SecurityPolicyIngressEgressInput]
        """

        self._egress = egress

    @property
    def apply_to(self):
        """Gets the apply_to of this SecurityPolicyCreateParams.  # noqa: E501


        :return: The apply_to of this SecurityPolicyCreateParams.  # noqa: E501
        :rtype: list[SecurityPolicyApplyToInput]
        """
        return self._apply_to

    @apply_to.setter
    def apply_to(self, apply_to):
        """Sets the apply_to of this SecurityPolicyCreateParams.


        :param apply_to: The apply_to of this SecurityPolicyCreateParams.  # noqa: E501
        :type apply_to: list[SecurityPolicyApplyToInput]
        """
        if (self.local_vars_configuration.client_side_validation and
                apply_to is not None and len(apply_to) < 1):
            raise ValueError("Invalid value for `apply_to`, number of items must be greater than or equal to `1`")  # noqa: E501

        self._apply_to = apply_to

    @property
    def policy_mode(self):
        """Gets the policy_mode of this SecurityPolicyCreateParams.  # noqa: E501


        :return: The policy_mode of this SecurityPolicyCreateParams.  # noqa: E501
        :rtype: PolicyMode
        """
        return self._policy_mode

    @policy_mode.setter
    def policy_mode(self, policy_mode):
        """Sets the policy_mode of this SecurityPolicyCreateParams.


        :param policy_mode: The policy_mode of this SecurityPolicyCreateParams.  # noqa: E501
        :type policy_mode: PolicyMode
        """

        self._policy_mode = policy_mode

    @property
    def everoute_cluster_id(self):
        """Gets the everoute_cluster_id of this SecurityPolicyCreateParams.  # noqa: E501


        :return: The everoute_cluster_id of this SecurityPolicyCreateParams.  # noqa: E501
        :rtype: str
        """
        return self._everoute_cluster_id

    @everoute_cluster_id.setter
    def everoute_cluster_id(self, everoute_cluster_id):
        """Sets the everoute_cluster_id of this SecurityPolicyCreateParams.


        :param everoute_cluster_id: The everoute_cluster_id of this SecurityPolicyCreateParams.  # noqa: E501
        :type everoute_cluster_id: str
        """
        if self.local_vars_configuration.client_side_validation and everoute_cluster_id is None:  # noqa: E501
            raise ValueError("Invalid value for `everoute_cluster_id`, must not be `None`")  # noqa: E501

        self._everoute_cluster_id = everoute_cluster_id

    @property
    def description(self):
        """Gets the description of this SecurityPolicyCreateParams.  # noqa: E501


        :return: The description of this SecurityPolicyCreateParams.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this SecurityPolicyCreateParams.


        :param description: The description of this SecurityPolicyCreateParams.  # noqa: E501
        :type description: str
        """

        self._description = description

    @property
    def name(self):
        """Gets the name of this SecurityPolicyCreateParams.  # noqa: E501


        :return: The name of this SecurityPolicyCreateParams.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SecurityPolicyCreateParams.


        :param name: The name of this SecurityPolicyCreateParams.  # noqa: E501
        :type name: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SecurityPolicyCreateParams):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SecurityPolicyCreateParams):
            return True

        return self.to_dict() != other.to_dict()
